<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if (!function_exists('LoadMimes')){
    function LoadMimes() {
        global $datadir;
        if (file_exists($datadir.'/mimes.txt'))
        {
            unset($GLOBALS["access"]);
            $GLOBALS["mimes"]=array();
            $GLOBALS["super_mimes"]=array();
            $GLOBALS["used_mime_types"]=array();
            $handle = fopen($datadir.'/mimes.txt', 'r');
            while (($data = fgetcsv($handle, 1000, "|")) !== FALSE) {
                $mime_type=$data[0];
                $description=$data[1];
                //$theArray = array($data[2]);
                $GLOBALS["mimes"] = array_push_assoc($GLOBALS["mimes"], $mime_type, $description);
                $theArray = array($GLOBALS["mimes"][$mime_type],$data[2]);
                $GLOBALS["super_mimes"] = array_push_assoc($GLOBALS["super_mimes"], $mime_type, $theArray);
                $extension = str_replace(".","\\.",$data[3]);
                $extension1 = str_replace(',','$|',$extension);
                if (strlen($extension1) > 0)
                    $extension1=$extension1.'$';
                $theArray1 = array($GLOBALS["mimes"][$mime_type],$data[2], $extension1);
                $GLOBALS["used_mime_types"] = array_push_assoc($GLOBALS["used_mime_types"], $mime_type, $theArray1);
            }
            fclose($handle);
        }
    }
}


if (!function_exists('get_mime_type')){
    function get_mime_type($item, $query) {
        if (count($GLOBALS["used_mime_types"]) == 0)
            LoadMimes();
        if (is_dir($item))
        {
            $mime_type = $GLOBALS["super_mimes"]["dir"][0];
            $image = $GLOBALS["super_mimes"]["dir"][1];

            if ($query == "img") return $image;
            else return $mime_type;
        }
        foreach($GLOBALS["used_mime_types"] as $mime) {
                list($desc,$img,$ext)   = $mime;
                if(@eregi($ext,$item)) {
                        $mime_type      = $desc;
                        $image          = $img;
                        if($query=="img") return $image;
                        else return $mime_type;
                }
        }
    }
}

if (!function_exists('array_push_assoc')){
    function array_push_assoc($array, $key, $value){
        $array[$key] = $value;
        return $array;
    }
}

if (!function_exists('parse_fsize_fm')) {
    function parse_fsize_fm($size) {               // parsed file size
        if($size >=1024)
            $size=pretty_number(round($size / 1024))." KB";
        elseif($size <1024 && $size > 0)
            $size="1 KB";
        elseif($size==0) $size="0 KB";

        return $size;
    }
}

if (!function_exists('pretty_number')) {
    function pretty_number($size) {
        $len=strlen($size);
        $place=0;
        $outval="";
        while ($len > 0) {
            $digit=substr($size,$len-1, 1);
            if ($place >= 3){
                $place = 0;
                $outval=$digit.",".$outval;
            }
            else
                $outval=$digit.$outval;
            $len--;
            $place++;
        }
        return($outval);
    }
}

if (!function_exists('print_version')) {
    function print_version() {
        global $homedir;
        $appinfo=dirname($homedir)."/appinfo.json";
        if (file_exists($appinfo)){
        $data = file_get_contents($appinfo);
            if(preg_match("/version=\"(.*)\"/", $data, $version))
                return $version[1];
        }
        else
            return "unknown";
    }
}

if (!function_exists('scanDirectory')) {
function scanDirectory($rootDir, $allowext) {
    $dirContent = scandir($rootDir);
    foreach($dirContent as $key => $content) {
        $path = $rootDir.$content;
        if(is_file($path) && is_readable($path)) {
            $ext = substr($content, strrpos($content, '.') + 1);
        
            if (is_array($allowext)) {
                if (in_array($ext, $allowext))
                    $allData[] = $content;
            }
            else
                $allData[] = $content;
        }
        else
            $allData[] = $content;
    }
    return $allData;
    }
}

if (!function_exists('killPid')){
    function killPid($pid)
    {
        shell_exec('kill -9 '.$pid);
    }
}

if (!function_exists('isPIDRunning')){
    function isPIDRunning($pid)
    {
        if ($pid)
        {
            $proc_dir="/proc/".$pid;
            if(file_exists($proc_dir))
            {
                //Pid is running
                return true;
            }else{
                //Pid is not running
                return false;
            }
        }
        else
            return false;
    }
}

if (!function_exists('File_Size')){
    function File_Size($file) {
        if (is_readable($file)) {
            $size = exec ('stat -c %s '. escapeshellarg ($file));
            return $size;
        }
    }
}

if (!function_exists('scan_dir')) {
    function scan_dir($dir)
    {
        $dh = opendir($dir);
        while (false !== ($filename = readdir($dh))) {
                $files[]=$filename;
        }
        sort($files);
        return $files;

    }
}

?>
