<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

//include db connection settings
if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $tmpdir, $rootdir;
ini_set("session.save_path", $tmpdir);
session_start();
LoadMimes();
if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
    header("Content-type: application/xhtml+xml"); } else {
    header("Content-type: text/xml");
}
echo("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
?>

<!-- start grid xml -->

<?php
if (! isset($_GET["dir"]))
    $dirToScan = $rootdir;
else
    $dirToScan = $_GET["dir"];

if (! isset($_GET["filter"]))
    $filters = "*";
else
    $filters = $_GET["filter"];

print("<rows id='0'>\n");

$filter = explode(",",$filters);
$files=scanDirectory($dirToScan, str_replace("*.","",$filter));
foreach($files as $file) {
    if ($file == "." || $file == "..") {
    }
    else {
        $fileFullPath=$dirToScan.$file;
        $image=get_mime_type($fileFullPath, "img");
        $actual_size = (float)File_Size($fileFullPath);
        $fsize = parse_fsize_fm($actual_size);

        $ftype=get_mime_type($fileFullPath, "type");

        $extn="";
        $pos=strrpos(basename($fileFullPath), ".");
        if ($pos) {
            $len=strlen(basename($fileFullPath));
            $extn=strtoupper(substr(basename($fileFullPath),$pos+1,$len-$pos));
        }
    
        if ($ftype == "")
            $ftype=$extn." File";

        if (is_dir($fileFullPath)){
            $fileFullPath=$fileFullPath.'/';
            $fsize="";
        }

        if (is_link($fileFullPath)) {
            if (file_exists($fileFullPath))
                $ftype="Symbolic Link";
            else {
                $ftype="Broken Link";
                $style='color:red';
            }
        }

        if ($image=="") $image="unknown.png";
        $xmlID=str_replace("&","&amp;",$fileFullPath);
        $xmlID=str_replace('"',"&quot;",$xmlID);
        $xmlID=str_replace("'","&apos;",$xmlID);
        print("<row id='".$xmlID."'>\n");
        print("<cell><![CDATA[_img/".$image."]]></cell>\n");
        print("<cell title='".$xmlID."'><![CDATA[".$file."]]></cell>\n");
        print("<cell><![CDATA[".$fsize."]]></cell>\n");
        print("<cell><![CDATA[".$ftype."]]></cell>\n");
        print("</row>\n");
    }
}
?>
<!-- close grid xml -->
</rows>
